Open CASCADE Technology: Geom_OffsetSurface Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
Geom_OffsetSurface Class Reference

Describes an offset surface in 3D space. An offset surface is defined by: More...

`#include <Geom_OffsetSurface.hxx>`

Inheritance diagram for Geom_OffsetSurface:
[legend]

## Public Member Functions
| Geom_OffsetSurface (const Handle< Geom_Surface > &S, const Standard_Real Offset, const Standard_Boolean isNotCheckC0=Standard_False)
| Constructs a surface offset from the basis surface S, where Offset is the distance between the offset surface and the basis surface at any point. A point on the offset surface is built by measuring the offset value along a normal vector at a point on S. This normal vector is given by the cross product D1u^D1v, where D1u and D1v are the vectors tangential to the basis surface in the u and v parametric directions at this point. The side of S on which the offset value is measured is indicated by this normal vector if Offset is positive, or is the inverse sense if Offset is negative. If isNotCheckC0 = TRUE checking if basis surface has C0-continuity is not made. Warnings : More...
void | SetBasisSurface (const Handle< Geom_Surface > &S, const Standard_Boolean isNotCheckC0=Standard_False)
| Raised if S is not at least C1. Warnings : No check is done to verify that a unique normal direction is defined at any point of the basis surface S. If isNotCheckC0 = TRUE checking if basis surface has C0-continuity is not made. Exceptions Standard_ConstructionError if the surface S is not at least "C1" continuous. More...
void | SetOffsetValue (const Standard_Real D)
| Changes this offset surface by assigning D as the offset value. More...
Standard_Real | Offset () const
| Returns the offset value of this offset surface. More...
Handle< Geom_Surface > | BasisSurface () const
| Returns the basis surface of this offset surface. Note: The basis surface can be an offset surface. More...
void | UReverse ()
| Changes the orientation of this offset surface in the u parametric direction. The bounds of the surface are not changed but the given parametric direction is reversed. More...
Standard_Real | UReversedParameter (const Standard_Real U) const
| Computes the u parameter on the modified surface, produced by reversing the u parametric direction of this offset surface, for any point of u parameter U on this offset surface. More...
void | VReverse ()
| Changes the orientation of this offset surface in the v parametric direction. The bounds of the surface are not changed but the given parametric direction is reversed. More...
Standard_Real | VReversedParameter (const Standard_Real V) const
| Computes the v parameter on the modified surface, produced by reversing the or v parametric direction of this offset surface, for any point of v parameter V on this offset surface. More...
void | Bounds (Standard_Real &U1, Standard_Real &U2, Standard_Real &V1, Standard_Real &V2) const
| Returns the parametric bounds U1, U2, V1 and V2 of this offset surface. If the surface is infinite, this function can return: More...
GeomAbs_Shape | Continuity () const
| This method returns the continuity of the basis surface - 1. Continuity of the Offset surface : C0 : only geometric continuity, C1 : continuity of the first derivative all along the Surface, C2 : continuity of the second derivative all along the Surface, C3 : continuity of the third derivative all along the Surface, CN : the order of continuity is infinite. Example : If the basis surface is C2 in the V direction and C3 in the U direction Shape = C1. Warnings : If the basis surface has a unique normal direction defined at any point this method gives the continuity of the offset surface otherwise the effective continuity can be lower than the continuity of the basis surface - 1. More...
Standard_Boolean | IsCNu (const Standard_Integer N) const
| This method answer True if the continuity of the basis surface is N + 1 in the U parametric direction. We suppose in this class that a unique normal is defined at any point on the basis surface. Raised if N <0. More...
Standard_Boolean | IsCNv (const Standard_Integer N) const
| This method answer True if the continuity of the basis surface is N + 1 in the V parametric direction. We suppose in this class that a unique normal is defined at any point on the basis surface. Raised if N <0. More...
Standard_Boolean | IsUClosed () const
| Checks whether this offset surface is closed in the u parametric direction. Returns true if, taking uFirst and uLast as the parametric bounds in the u parametric direction, the distance between the points P(uFirst,v) and P(uLast,v) is less than or equal to gp::Resolution() for each value of the parameter v. More...
Standard_Boolean | IsVClosed () const
| Checks whether this offset surface is closed in the u or v parametric direction. Returns true if taking vFirst and vLast as the parametric bounds in the v parametric direction, the distance between the points P(u,vFirst) and P(u,vLast) is less than or equal to gp::Resolution() for each value of the parameter u. More...
Standard_Boolean | IsUPeriodic () const
| Returns true if this offset surface is periodic in the u parametric direction, i.e. if the basis surface of this offset surface is periodic in this direction. More...
virtual Standard_Real | UPeriod () const
| Returns the period of this offset surface in the u parametric direction respectively, i.e. the period of the basis surface of this offset surface in this parametric direction. raises if the surface is not uperiodic. More...
Standard_Boolean | IsVPeriodic () const
| Returns true if this offset surface is periodic in the v parametric direction, i.e. if the basis surface of this offset surface is periodic in this direction. More...
virtual Standard_Real | VPeriod () const
| Returns the period of this offset surface in the v parametric direction respectively, i.e. the period of the basis surface of this offset surface in this parametric direction. raises if the surface is not vperiodic. More...
Handle< Geom_Curve > | UIso (const Standard_Real U) const
| Computes the U isoparametric curve. More...
Handle< Geom_Curve > | VIso (const Standard_Real V) const
| Computes the V isoparametric curve. More...
void | D0 (const Standard_Real U, const Standard_Real V, gp_Pnt &P) const
| P (U, V) = Pbasis + Offset * Ndir where Ndir = D1Ubasis ^ D1Vbasis / ||D1Ubasis ^ D1Vbasis|| is the normal direction of the basis surface. Pbasis, D1Ubasis, D1Vbasis are the point and the first derivatives on the basis surface. If Ndir is undefined this method computes an approched normal direction using the following limited development : Ndir = N0 + DNdir/DU + DNdir/DV + Eps with Eps->0 which requires to compute the second derivatives on the basis surface. If the normal direction cannot be approximate for this order of derivation the exception UndefinedValue is raised. More...
void | D1 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V) const
| Raised if the continuity of the basis surface is not C2. More...
void | D2 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V, gp_Vec &D2U, gp_Vec &D2V, gp_Vec &D2UV) const
| —Purpose ; Raised if the continuity of the basis surface is not C3. More...
void | D3 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V, gp_Vec &D2U, gp_Vec &D2V, gp_Vec &D2UV, gp_Vec &D3U, gp_Vec &D3V, gp_Vec &D3UUV, gp_Vec &D3UVV) const
| Raised if the continuity of the basis surface is not C4. More...
gp_Vec | DN (const Standard_Real U, const Standard_Real V, const Standard_Integer Nu, const Standard_Integer Nv) const
| Computes the derivative of order Nu in the direction u and Nv in the direction v. —Purpose ; Raised if the continuity of the basis surface is not CNu + 1 in the U direction and CNv + 1 in the V direction. Raised if Nu + Nv < 1 or Nu < 0 or Nv < 0. More...
void | Value (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Pnt &Pbasis, gp_Vec &D1Ubasis, gp_Vec &D1Vbasis) const
| P (U, V) = Pbasis + Offset * Ndir where Ndir = D1Ubasis ^ D1Vbasis / ||D1Ubasis ^ D1Vbasis|| is the normal direction of the surface. If Ndir is undefined this method computes an approched normal direction using the following limited development : Ndir = N0 + DNdir/DU + DNdir/DV + Eps with Eps->0 which requires to compute the second derivatives on the basis surface. If the normal direction cannot be approximate for this order of derivation the exception UndefinedValue is raised. More...
void | D1 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Pnt &Pbasis, gp_Vec &D1U, gp_Vec &D1V, gp_Vec &D1Ubasis, gp_Vec &D1Vbasis, gp_Vec &D2Ubasis, gp_Vec &D2Vbasis, gp_Vec &D2UVbasis) const
| Raised if the continuity of the basis surface is not C2. More...
void | D2 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Pnt &Pbasis, gp_Vec &D1U, gp_Vec &D1V, gp_Vec &D2U, gp_Vec &D2V, gp_Vec &D2UV, gp_Vec &D1Ubasis, gp_Vec &D1Vbasis, gp_Vec &D2Ubasis, gp_Vec &D2Vbasis, gp_Vec &D2UVbasis, gp_Vec &D3Ubasis, gp_Vec &D3Vbasis, gp_Vec &D3UUVbasis, gp_Vec &D3UVVbasis) const
| Raised if the continuity of the basis surface is not C3. The following private methods includes common part of local and global methods of derivative evaluations. More...
void | LocalD0 (const Standard_Real U, const Standard_Real V, const Standard_Integer USide, const Standard_Integer VSide, gp_Pnt &P) const
void | LocalD1 (const Standard_Real U, const Standard_Real V, const Standard_Integer USide, const Standard_Integer VSide, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V) const
void | LocalD2 (const Standard_Real U, const Standard_Real V, const Standard_Integer USide, const Standard_Integer VSide, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V, gp_Vec &D2U, gp_Vec &D2V, gp_Vec &D2UV) const
void | LocalD3 (const Standard_Real U, const Standard_Real V, const Standard_Integer USide, const Standard_Integer VSide, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V, gp_Vec &D2U, gp_Vec &D2V, gp_Vec &D2UV, gp_Vec &D3U, gp_Vec &D3V, gp_Vec &D3UUV, gp_Vec &D3UVV) const
gp_Vec | LocalDN (const Standard_Real U, const Standard_Real V, const Standard_Integer USide, const Standard_Integer VSide, const Standard_Integer Nu, const Standard_Integer Nv) const
void | Transform (const gp_Trsf &T)
| Applies the transformation T to this offset surface. Note: the basis surface is also modified. More...
virtual void | TransformParameters (Standard_Real &U, Standard_Real &V, const gp_Trsf &T) const
| Computes the parameters on the transformed surface for the transform of the point of parameters U,V on <me>. More...
virtual gp_GTrsf2d | ParametricTransformation (const gp_Trsf &T) const
| Returns a 2d transformation used to find the new parameters of a point on the transformed surface. More...
Handle< Geom_Geometry > | Copy () const
| Creates a new object which is a copy of this offset surface. More...
Handle< Geom_Surface > | Surface () const
| returns an equivalent surface of the offset surface when the basis surface is a canonic surface or a rectangular limited surface on canonic surface or if the offset is null. More...
Standard_Boolean | UOsculatingSurface (const Standard_Real U, const Standard_Real V, Standard_Boolean &IsOpposite, Handle< Geom_BSplineSurface > &UOsculSurf) const
| if Standard_True, L is the local osculating surface along U at the point U,V. It means that DL/DU is collinear to DS/DU . If IsOpposite == Standard_True these vectors have opposite direction. More...
Standard_Boolean | VOsculatingSurface (const Standard_Real U, const Standard_Real V, Standard_Boolean &IsOpposite, Handle< Geom_BSplineSurface > &VOsculSurf) const
| if Standard_True, L is the local osculating surface along V at the point U,V. It means that DL/DV is collinear to DS/DV . If IsOpposite == Standard_True these vectors have opposite direction. More...
GeomAbs_Shape | GetBasisSurfContinuity () const
| Returns continuity of the basis surface. More...
Public Member Functions inherited from Geom_Surface
Handle< Geom_Surface > | UReversed () const
| Reverses the U direction of parametrization of <me>. The bounds of the surface are not modified. A copy of <me> is returned. More...
Handle< Geom_Surface > | VReversed () const
| Reverses the V direction of parametrization of <me>. The bounds of the surface are not modified. A copy of <me> is returned. More...
gp_Pnt | Value (const Standard_Real U, const Standard_Real V) const
| Computes the point of parameter U on the surface. More...
Public Member Functions inherited from Geom_Geometry
void | Mirror (const gp_Pnt &P)
| Performs the symmetrical transformation of a Geometry with respect to the point P which is the center of the symmetry. More...
void | Mirror (const gp_Ax1 &A1)
| Performs the symmetrical transformation of a Geometry with respect to an axis placement which is the axis of the symmetry. More...
void | Mirror (const gp_Ax2 &A2)
| Performs the symmetrical transformation of a Geometry with respect to a plane. The axis placement A2 locates the plane of the symmetry : (Location, XDirection, YDirection). More...
void | Rotate (const gp_Ax1 &A1, const Standard_Real Ang)
| Rotates a Geometry. A1 is the axis of the rotation. Ang is the angular value of the rotation in radians. More...
void | Scale (const gp_Pnt &P, const Standard_Real S)
| Scales a Geometry. S is the scaling value. More...
void | Translate (const gp_Vec &V)
| Translates a Geometry. V is the vector of the tanslation. More...
void | Translate (const gp_Pnt &P1, const gp_Pnt &P2)
| Translates a Geometry from the point P1 to the point P2. More...
Handle< Geom_Geometry > | Mirrored (const gp_Pnt &P) const
Handle< Geom_Geometry > | Mirrored (const gp_Ax1 &A1) const
Handle< Geom_Geometry > | Mirrored (const gp_Ax2 &A2) const
Handle< Geom_Geometry > | Rotated (const gp_Ax1 &A1, const Standard_Real Ang) const
Handle< Geom_Geometry > | Scaled (const gp_Pnt &P, const Standard_Real S) const
Handle< Geom_Geometry > | Transformed (const gp_Trsf &T) const
Handle< Geom_Geometry > | Translated (const gp_Vec &V) const
Handle< Geom_Geometry > | Translated (const gp_Pnt &P1, const gp_Pnt &P2) const
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Detailed Description

Describes an offset surface in 3D space. An offset surface is defined by:

- the basis surface to which it is parallel, and
- the distance between the offset surface and its basis surface. A point on the offset surface is built by measuring the offset value along the normal vector at a point on the basis surface. This normal vector is given by the cross product D1u^D1v, where D1u and D1v are the vectors tangential to the basis surface in the u and v parametric directions at this point. The side of the basis surface on which the offset is measured depends on the sign of the offset value. A Geom_OffsetSurface surface can be self-intersecting, even if the basis surface does not self-intersect. The self-intersecting portions are not deleted at the time of construction. Warning There must be only one normal vector defined at any point on the basis surface. This must be verified by the user as no check is made at the time of construction to detect points with multiple possible normal directions (for example, the top of a conical surface).

## Constructor & Destructor Documentation

Geom_OffsetSurface::Geom_OffsetSurface | ( | const Handle< Geom_Surface > & | S,
|  | const Standard_Real | Offset,
|  | const Standard_Boolean | isNotCheckC0 = `Standard_False`
| ) |  |

Constructs a surface offset from the basis surface S, where Offset is the distance between the offset surface and the basis surface at any point. A point on the offset surface is built by measuring the offset value along a normal vector at a point on S. This normal vector is given by the cross product D1u^D1v, where D1u and D1v are the vectors tangential to the basis surface in the u and v parametric directions at this point. The side of S on which the offset value is measured is indicated by this normal vector if Offset is positive, or is the inverse sense if Offset is negative. If isNotCheckC0 = TRUE checking if basis surface has C0-continuity is not made. Warnings :

- The offset surface is built with a copy of the surface S. Therefore, when S is modified the offset surface is not modified.
- No check is made at the time of construction to detect points on S with multiple possible normal directions. Raised if S is not at least C1. Warnings : No check is done to verify that a unique normal direction is defined at any point of the basis surface S.

## Member Function Documentation

Handle< Geom_Surface > Geom_OffsetSurface::BasisSurface | ( |  | ) | const

Returns the basis surface of this offset surface. Note: The basis surface can be an offset surface.

void Geom_OffsetSurface::Bounds | ( | Standard_Real & | U1,
|  | Standard_Real & | U2,
|  | Standard_Real & | V1,
|  | Standard_Real & | V2
| ) |  | const
| virtual

Returns the parametric bounds U1, U2, V1 and V2 of this offset surface. If the surface is infinite, this function can return:

- Standard_Real::RealFirst(), or
- Standard_Real::RealLast().

Implements Geom_Surface.

GeomAbs_Shape Geom_OffsetSurface::Continuity | ( |  | ) | const
| virtual

This method returns the continuity of the basis surface - 1. Continuity of the Offset surface : C0 : only geometric continuity, C1 : continuity of the first derivative all along the Surface, C2 : continuity of the second derivative all along the Surface, C3 : continuity of the third derivative all along the Surface, CN : the order of continuity is infinite. Example : If the basis surface is C2 in the V direction and C3 in the U direction Shape = C1. Warnings : If the basis surface has a unique normal direction defined at any point this method gives the continuity of the offset surface otherwise the effective continuity can be lower than the continuity of the basis surface - 1.

Implements Geom_Surface.

Handle< Geom_Geometry > Geom_OffsetSurface::Copy | ( |  | ) | const
| virtual

Creates a new object which is a copy of this offset surface.

Implements Geom_Geometry.

void Geom_OffsetSurface::D0 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P
| ) |  | const
| virtual

P (U, V) = Pbasis + Offset * Ndir where Ndir = D1Ubasis ^ D1Vbasis / ||D1Ubasis ^ D1Vbasis|| is the normal direction of the basis surface. Pbasis, D1Ubasis, D1Vbasis are the point and the first derivatives on the basis surface. If Ndir is undefined this method computes an approched normal direction using the following limited development : Ndir = N0 + DNdir/DU + DNdir/DV + Eps with Eps->0 which requires to compute the second derivatives on the basis surface. If the normal direction cannot be approximate for this order of derivation the exception UndefinedValue is raised.

Raised if the continuity of the basis surface is not C1. Raised if the order of derivation required to compute the normal direction is greater than the second order.

Implements Geom_Surface.

void Geom_OffsetSurface::D1 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V
| ) |  | const
| virtual

Raised if the continuity of the basis surface is not C2.

Implements Geom_Surface.

void Geom_OffsetSurface::D1 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P,
|  | gp_Pnt & | Pbasis,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V,
|  | gp_Vec & | D1Ubasis,
|  | gp_Vec & | D1Vbasis,
|  | gp_Vec & | D2Ubasis,
|  | gp_Vec & | D2Vbasis,
|  | gp_Vec & | D2UVbasis
| ) |  | const

Raised if the continuity of the basis surface is not C2.

void Geom_OffsetSurface::D2 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V,
|  | gp_Vec & | D2U,
|  | gp_Vec & | D2V,
|  | gp_Vec & | D2UV
| ) |  | const
| virtual

—Purpose ; Raised if the continuity of the basis surface is not C3.

Implements Geom_Surface.

void Geom_OffsetSurface::D2 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P,
|  | gp_Pnt & | Pbasis,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V,
|  | gp_Vec & | D2U,
|  | gp_Vec & | D2V,
|  | gp_Vec & | D2UV,
|  | gp_Vec & | D1Ubasis,
|  | gp_Vec & | D1Vbasis,
|  | gp_Vec & | D2Ubasis,
|  | gp_Vec & | D2Vbasis,
|  | gp_Vec & | D2UVbasis,
|  | gp_Vec & | D3Ubasis,
|  | gp_Vec & | D3Vbasis,
|  | gp_Vec & | D3UUVbasis,
|  | gp_Vec & | D3UVVbasis
| ) |  | const

Raised if the continuity of the basis surface is not C3. The following private methods includes common part of local and global methods of derivative evaluations.

void Geom_OffsetSurface::D3 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V,
|  | gp_Vec & | D2U,
|  | gp_Vec & | D2V,
|  | gp_Vec & | D2UV,
|  | gp_Vec & | D3U,
|  | gp_Vec & | D3V,
|  | gp_Vec & | D3UUV,
|  | gp_Vec & | D3UVV
| ) |  | const
| virtual

Raised if the continuity of the basis surface is not C4.

Implements Geom_Surface.

gp_Vec Geom_OffsetSurface::DN | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | const Standard_Integer | Nu,
|  | const Standard_Integer | Nv
| ) |  | const
| virtual

Computes the derivative of order Nu in the direction u and Nv in the direction v. —Purpose ; Raised if the continuity of the basis surface is not CNu + 1 in the U direction and CNv + 1 in the V direction. Raised if Nu + Nv < 1 or Nu < 0 or Nv < 0.

The following methods compute the value and derivatives on the offset surface and returns the derivatives on the basis surface too. The computation of the value and derivatives on the basis surface are used to evaluate the offset surface.

Warnings : The exception UndefinedValue or UndefinedDerivative is raised if it is not possible to compute a unique offset direction.

Implements Geom_Surface.

GeomAbs_Shape Geom_OffsetSurface::GetBasisSurfContinuity | ( |  | ) | const

Returns continuity of the basis surface.

Standard_Boolean Geom_OffsetSurface::IsCNu | ( | const Standard_Integer | N | ) | const
| virtual

This method answer True if the continuity of the basis surface is N + 1 in the U parametric direction. We suppose in this class that a unique normal is defined at any point on the basis surface. Raised if N <0.

Implements Geom_Surface.

Standard_Boolean Geom_OffsetSurface::IsCNv | ( | const Standard_Integer | N | ) | const
| virtual

This method answer True if the continuity of the basis surface is N + 1 in the V parametric direction. We suppose in this class that a unique normal is defined at any point on the basis surface. Raised if N <0.

Implements Geom_Surface.

Standard_Boolean Geom_OffsetSurface::IsUClosed | ( |  | ) | const
| virtual

Checks whether this offset surface is closed in the u parametric direction. Returns true if, taking uFirst and uLast as the parametric bounds in the u parametric direction, the distance between the points P(uFirst,v) and P(uLast,v) is less than or equal to gp::Resolution() for each value of the parameter v.

Implements Geom_Surface.

Standard_Boolean Geom_OffsetSurface::IsUPeriodic | ( |  | ) | const
| virtual

Returns true if this offset surface is periodic in the u parametric direction, i.e. if the basis surface of this offset surface is periodic in this direction.

Implements Geom_Surface.

Standard_Boolean Geom_OffsetSurface::IsVClosed | ( |  | ) | const
| virtual

Checks whether this offset surface is closed in the u or v parametric direction. Returns true if taking vFirst and vLast as the parametric bounds in the v parametric direction, the distance between the points P(u,vFirst) and P(u,vLast) is less than or equal to gp::Resolution() for each value of the parameter u.

Implements Geom_Surface.

Standard_Boolean Geom_OffsetSurface::IsVPeriodic | ( |  | ) | const
| virtual

Returns true if this offset surface is periodic in the v parametric direction, i.e. if the basis surface of this offset surface is periodic in this direction.

Implements Geom_Surface.

void Geom_OffsetSurface::LocalD0 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | const Standard_Integer | USide,
|  | const Standard_Integer | VSide,
|  | gp_Pnt & | P
| ) |  | const

void Geom_OffsetSurface::LocalD1 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | const Standard_Integer | USide,
|  | const Standard_Integer | VSide,
|  | gp_Pnt & | P,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V
| ) |  | const

void Geom_OffsetSurface::LocalD2 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | const Standard_Integer | USide,
|  | const Standard_Integer | VSide,
|  | gp_Pnt & | P,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V,
|  | gp_Vec & | D2U,
|  | gp_Vec & | D2V,
|  | gp_Vec & | D2UV
| ) |  | const

void Geom_OffsetSurface::LocalD3 | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | const Standard_Integer | USide,
|  | const Standard_Integer | VSide,
|  | gp_Pnt & | P,
|  | gp_Vec & | D1U,
|  | gp_Vec & | D1V,
|  | gp_Vec & | D2U,
|  | gp_Vec & | D2V,
|  | gp_Vec & | D2UV,
|  | gp_Vec & | D3U,
|  | gp_Vec & | D3V,
|  | gp_Vec & | D3UUV,
|  | gp_Vec & | D3UVV
| ) |  | const

gp_Vec Geom_OffsetSurface::LocalDN | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | const Standard_Integer | USide,
|  | const Standard_Integer | VSide,
|  | const Standard_Integer | Nu,
|  | const Standard_Integer | Nv
| ) |  | const

Standard_Real Geom_OffsetSurface::Offset | ( |  | ) | const

Returns the offset value of this offset surface.

virtual gp_GTrsf2d Geom_OffsetSurface::ParametricTransformation | ( | const gp_Trsf & | T | ) | const
| virtual

Returns a 2d transformation used to find the new parameters of a point on the transformed surface.

me->Transformed(T)->Value(U',V')

is the same point as

me->Value(U,V).Transformed(T)

Where U',V' are obtained by transforming U,V with th 2d transformation returned by

me->ParametricTransformation(T)

This methods calls the basis surface method.

Reimplemented from Geom_Surface.

void Geom_OffsetSurface::SetBasisSurface | ( | const Handle< Geom_Surface > & | S,
|  | const Standard_Boolean | isNotCheckC0 = `Standard_False`
| ) |  |

Raised if S is not at least C1. Warnings : No check is done to verify that a unique normal direction is defined at any point of the basis surface S. If isNotCheckC0 = TRUE checking if basis surface has C0-continuity is not made. Exceptions Standard_ConstructionError if the surface S is not at least "C1" continuous.

void Geom_OffsetSurface::SetOffsetValue | ( | const Standard_Real | D | ) |

Changes this offset surface by assigning D as the offset value.

Handle< Geom_Surface > Geom_OffsetSurface::Surface | ( |  | ) | const

returns an equivalent surface of the offset surface when the basis surface is a canonic surface or a rectangular limited surface on canonic surface or if the offset is null.

void Geom_OffsetSurface::Transform | ( | const gp_Trsf & | T | ) |
| virtual

Applies the transformation T to this offset surface. Note: the basis surface is also modified.

Implements Geom_Geometry.

virtual void Geom_OffsetSurface::TransformParameters | ( | Standard_Real & | U,
|  | Standard_Real & | V,
|  | const gp_Trsf & | T
| ) |  | const
| virtual

Computes the parameters on the transformed surface for the transform of the point of parameters U,V on <me>.

me->Transformed(T)->Value(U',V')

is the same point as

me->Value(U,V).Transformed(T)

Where U',V' are the new values of U,V after calling

me->TranformParameters(U,V,T) This methods calls the basis surface method.

Reimplemented from Geom_Surface.

Handle< Geom_Curve > Geom_OffsetSurface::UIso | ( | const Standard_Real | U | ) | const
| virtual

Computes the U isoparametric curve.

Implements Geom_Surface.

Standard_Boolean Geom_OffsetSurface::UOsculatingSurface | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | Standard_Boolean & | IsOpposite,
|  | Handle< Geom_BSplineSurface > & | UOsculSurf
| ) |  | const

if Standard_True, L is the local osculating surface along U at the point U,V. It means that DL/DU is collinear to DS/DU . If IsOpposite == Standard_True these vectors have opposite direction.

virtual Standard_Real Geom_OffsetSurface::UPeriod | ( |  | ) | const
| virtual

Returns the period of this offset surface in the u parametric direction respectively, i.e. the period of the basis surface of this offset surface in this parametric direction. raises if the surface is not uperiodic.

Reimplemented from Geom_Surface.

void Geom_OffsetSurface::UReverse | ( |  | ) |
| virtual

Changes the orientation of this offset surface in the u parametric direction. The bounds of the surface are not changed but the given parametric direction is reversed.

Implements Geom_Surface.

Standard_Real Geom_OffsetSurface::UReversedParameter | ( | const Standard_Real | U | ) | const
| virtual

Computes the u parameter on the modified surface, produced by reversing the u parametric direction of this offset surface, for any point of u parameter U on this offset surface.

Implements Geom_Surface.

void Geom_OffsetSurface::Value | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | gp_Pnt & | P,
|  | gp_Pnt & | Pbasis,
|  | gp_Vec & | D1Ubasis,
|  | gp_Vec & | D1Vbasis
| ) |  | const

P (U, V) = Pbasis + Offset * Ndir where Ndir = D1Ubasis ^ D1Vbasis / ||D1Ubasis ^ D1Vbasis|| is the normal direction of the surface. If Ndir is undefined this method computes an approched normal direction using the following limited development : Ndir = N0 + DNdir/DU + DNdir/DV + Eps with Eps->0 which requires to compute the second derivatives on the basis surface. If the normal direction cannot be approximate for this order of derivation the exception UndefinedValue is raised.

Raised if the continuity of the basis surface is not C1. Raised if the order of derivation required to compute the normal direction is greater than the second order.

Handle< Geom_Curve > Geom_OffsetSurface::VIso | ( | const Standard_Real | V | ) | const
| virtual

Computes the V isoparametric curve.

Te followings methods compute value and derivatives.

Warnings An exception is raised if a unique normal vector is not defined on the basis surface for the parametric value (U,V). No check is done at the creation time and we suppose in this package that the offset surface can be defined at any point.

Implements Geom_Surface.

Standard_Boolean Geom_OffsetSurface::VOsculatingSurface | ( | const Standard_Real | U,
|  | const Standard_Real | V,
|  | Standard_Boolean & | IsOpposite,
|  | Handle< Geom_BSplineSurface > & | VOsculSurf
| ) |  | const

if Standard_True, L is the local osculating surface along V at the point U,V. It means that DL/DV is collinear to DS/DV . If IsOpposite == Standard_True these vectors have opposite direction.

virtual Standard_Real Geom_OffsetSurface::VPeriod | ( |  | ) | const
| virtual

Returns the period of this offset surface in the v parametric direction respectively, i.e. the period of the basis surface of this offset surface in this parametric direction. raises if the surface is not vperiodic.

Reimplemented from Geom_Surface.

void Geom_OffsetSurface::VReverse | ( |  | ) |
| virtual

Changes the orientation of this offset surface in the v parametric direction. The bounds of the surface are not changed but the given parametric direction is reversed.

Implements Geom_Surface.

Standard_Real Geom_OffsetSurface::VReversedParameter | ( | const Standard_Real | V | ) | const
| virtual

Computes the v parameter on the modified surface, produced by reversing the or v parametric direction of this offset surface, for any point of v parameter V on this offset surface.

Implements Geom_Surface.

The documentation for this class was generated from the following file:

- Geom_OffsetSurface.hxx